<template>
  <div class="app-container">

    <div v-if="show==0">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">

        <el-form-item label="单据编号" prop="billNumber">
          <el-input
            v-model="queryParams.billNumber"
            placeholder="请输入单据编号"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="航次号" prop="voyageNo">
          <el-input
            v-model="queryParams.voyageNo"
            placeholder="请输入航次号"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>


        <el-form-item label="船舶名称" prop="vesselName">
          <el-input
            v-model="queryParams.vesselName"
            placeholder="请输入船舶名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="货物名称" prop="cargoName">
          <el-input
            v-model="queryParams.cargoName"
            placeholder="请输入货物名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="库场名称" prop="stockName">
          <el-input
            v-model="queryParams.stockName"
            placeholder="请输入库场名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="单据日期" prop="queryTime">
          <el-date-picker clearable
                          v-model="queryTime"
                          type="daterange"
                          :picker-options="pickerOptions"
                          value-format="yyyy-MM-dd"
                          end-placeholder="结束日期"
                          range-separator="-" start-placeholder="开始日期"
                          placeholder="请选择单据日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10" class="mb8">


        <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['jxc:ckcargo:export']"
          >导出
          </el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>

      <el-table v-loading="loading" :data="tableData" @sort-change="handleSortChange"
                @selection-change="handleSelectionChange"
                row-key="id" highlight-current-row
                :tree-props="{children: 'children', hasChildren: 'hasChildren'}" >
        <el-table-column type="selection" width="55" align="center"/>

        <el-table-column label="单据信息" align="center">
        <el-table-column label="单据编号" align="center" prop="billNumber" sortable='custom' width="100"/>
        <el-table-column label="单据日期" align="center" prop="billDate" width="180" sortable='custom'>
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.billDate, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>

          </template>
        </el-table-column>
        </el-table-column>
        <el-table-column label="货物信息" align="center">
        <el-table-column label="出库单据" align="center" prop="outBill" sortable='custom' width="100"/>
        <el-table-column label="HS编号" align="center" prop="hsCode" sortable='custom' width="100"/>
        <el-table-column label="货物名称" align="center" prop="cargoName" sortable='custom' width="100"/>
        <el-table-column label="规格类型品质" align="center" prop="cargoSpec" sortable='custom' width="130"/>

        <el-table-column label="提运单号" align="center" prop="billNo" sortable='custom' width="100"/>

        <el-table-column label="货主名称" align="center" prop="custName" sortable='custom' width="100"/>
        <el-table-column label="货物重量" align="center" prop="cargoWt" sortable='custom' width="100"/>
        <el-table-column label="库场名称" align="center" prop="stockName" sortable='custom' width="100"/>
        <el-table-column label="出入库类型" align="center" prop="inoutType" sortable='custom' width="140"/>
        </el-table-column>
        <el-table-column label="船舶信息" align="center">
        <el-table-column label="航次号" align="center" prop="voyageNo" sortable='custom' width="100"/>
        <el-table-column label="船舶名称" align="center" prop="vesselName" sortable='custom' width="100"/>
        </el-table-column>




      </el-table>

      <pagination
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </div>





  </div>
</template>

<script>
import {
  pageListCkcargo,
  getCkcargo,
  delCkcargo,
  addCkcargo,
  updateCkcargo,
  addCkcargoConfirmOrder
} from "@/api/jxc/ckcargo";
import {listStock} from "@/api/jxc/stock";
import {listCust} from "@/api/jxc/cust";
import {listCargo} from "@/api/jxc/cargo";
import {listVessel,} from "@/api/jxc/vessel";
import {listBmvoyage} from "@/api/jxc/bmvoyage";
import { warehouseList } from '@/api/jxc/ckstock'
import { addMixture } from '@/api/jxc/ckbill'


export default {
  name: "Transfer",
  dicts: ['sys_business_nature', 'sys_trade_nature', 'sys_inbound_outbound_type'],
  data() {
    return {
      pickerOptions: {
        shortcuts: [{
          text: '最近一周',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近一个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        }]
      },

      tableData: [{
        id: 3,
        billDate:'2021-01-01',
        billNumber: '1',
        cargoName: '钢铁',
        stockName: '一号库场',
        custName: '货主名称',
        outBill:'出库单据',
        inoutType: '入库',



        cargoNum: '1519 ',
        cargoWt:'11',
        cargoVol:'120',
        children: [{
          id: 31,
          inoutType: '出库',
          cargoName: '钢铁',
          stockName: '二号库场',
          custName: '货主名称',
          outBill:'出库单据',



          cargoNum: '1519 ',
          cargoWt:'11',
          cargoVol:'120',

        }]
      }],


      activeName: ['1', '2', '3'],


      inCargoWt: null,
      inCargoVol: null,
      inCargoNum: null,
      outCargoWt: null,
      outCargoVol: null,
      outCargoNum: null,


      show: 0,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 选中名字
      names: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 单据时间
      queryTime: [],
      // 船舶航次表格数据
      bmvoyageList: [],
      // 船舱表格数据
      vesselList: [],
      // 客户表格数据
      custList: [],
      // 货物表格数据
      cargoList: [],
      // 仓库表格数据
      stockList: [],
      listMap: {},
      // 货物转场表格数据
      ckcargoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        billId: null,
        billDate: null,
        billNumber: null,
        inoutType: null,
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        inStockId: null,
        inStockCode: null,
        inStockName: null,
        outStockId: null,
        outStockCode: null,
        outStockName: null,
        beginDate: null,
        endDate: null,
      },
      // 表单参数
      form: {
        outBillNumber:'',
        stockId:'',
        nowStockNum:0,
        nowStockWt:0,
        nowStockVol:0,
      },
      outForm: {
        outBillNumber:'',
        stockId:'',
        nowStockNum:0,
        nowStockWt:0,
        nowStockVol:0,
      },
      inForm: {
        outBillNumber:'',
        stockId:'',
        nowStockNum:0,
        nowStockWt:0,
        nowStockVol:0,
      },
      // 表单校验
      rules: {
        billDate: [
          {required: true, message: "单据日期不能为空", trigger: "blur"}
        ],
        billNumber: [
          {required: true, message: "单据编号不能为空", trigger: "blur"}
        ],
        cargoId: [
          {required: true, message: "货物名称不能为空", trigger: "blur"}
        ],
        custId: [
          {required: true, message: "货主名称不能为空", trigger: "blur"}
        ],
        stockId: [
          {required: true, message: "库场不能为空", trigger: "blur"}
        ],
        outBillNumber: [
          {required: true, message: "单据编号不能为空", trigger: "blur"}
        ],
      },


    };
  },
  created() {
    this.getList();
    this.getCustList();
    this.getCargoList();
    this.getVesselList();
    this.getBmvoyage();


  },
  methods: {

    //航次
    setBmvoyageDetail(voyageId) {
      console.log(voyageId);

      this.bmvoyageList.forEach(ele => {
        if (ele.id == voyageId) {
          this.form.voyageNo = ele.voyageNo;
          this.form.vesselName = ele.vesselName;
          this.form.deptId = ele.deptId;
          this.form.vesselId = ele.vesselId;
          this.form.netTon = ele.netTon;
          this.form.opType = ele.opType;


        }
      })
    },
    getBmvoyage() {
      let param = {};
      listBmvoyage(param).then(response => {
        this.bmvoyageList = response.data;
      }).catch(e => {
      });
    },

    //船舶
    setVesselDetail(vesselId) {
      console.log(vesselId);
      this.vesselList.forEach(ele => {
        if (ele.id == vesselId) {
          console.log("aa:", ele.voyageNo);
          this.form.vesselName = ele.vesselName;

        }
      })
    },

    getVesselList() {
      let param = {};
      listVessel(param).then(response => {
        this.vesselList = response.data;
      }).catch(e => {
      });
    },

    //货物
    setCargoDetail(cargoId) {
      if(!this.form.custId){
        this.form.cargoId='';
        this.$modal.alertError("请先选择客户信息");
        return
      }
      this.$set(this.outForm,"stockId","");
      this.$set(this.outForm,"outBillNumber","");
      this.cargoList.forEach(ele => {
        if (ele.id == cargoId) {
          this.form.cargoName = ele.cargoName;
          this.form.hsCode = ele.hsCode;
          this.form.cargoSpec = ele.cargoSpec;
          this.form.originCountry = ele.originCountry;
        }
      })
      this.getStockList(cargoId);
    },

    getCargoList() {
      let param = {};
      listCargo(param).then(response => {
        this.cargoList = response.data;
      }).catch(e => {
      });
    },

    //客户
    setCustDetail(custId) {
      this.custList.forEach(ele => {
        if (ele.id == custId) {
          this.form.custName = ele.custName;
          this.form.custCode = ele.custCode;

        }
      })
    },

    getCustList() {
      let param = {};
      listCust(param).then(response => {
        this.custList = response.data;
      }).catch(e => {
      });
    },


    //仓库
    setInStockDetail(stockId) {
      this.stockList.forEach(ele => {
        if (ele.id == stockId) {
          this.inForm.stockName = ele.stockName;
          this.inForm.stockCode = ele.stockCode;
        }
      })
    },
    //入库数量
    setInCargoNum() {
      this.outForm.cargoNum = this.form.nowStockNum - this.inForm.cargoNum
    },
    setInCargoWt() {
      this.outForm.cargoWt = this.form.nowStockWt - this.inForm.cargoWt
    },
    setInCargoVol() {
      this.outForm.cargoVol = this.form.nowStockVol- this.inForm.cargoVol
    },
    //仓库
    setOutStockDetail(stockId) {
      this.$set(this.outForm,"billNumber","");
      this.stockList.forEach(ele => {
        if (ele.stockId == stockId) {
          this.outForm.stockName = ele.stockName;
          this.outForm.stockCode = ele.stockCode;
          this.outForm.stockId = stockId;
        }
      })
    },
    //设置现有库存
    setNowStockNum(billNumber) {
      this.listMap[this.outForm.stockId].forEach(ele => {
        if (ele.billNumber == billNumber) {
          this.$set(this.form,"nowStockNum",ele.cargoNum);
          this.$set(this.form,"nowStockWt",ele.cargoWt);
          this.$set(this.form,"nowStockVol",ele.cargoVol);
          this.outForm.billNumber = ele.billNumber;
          this.outForm.cargoNum = ele.cargoNum;
          this.outForm.cargoWt = ele.cargoWt;
          this.outForm.cargoVol = ele.cargoVol;
          this.inForm.cargoNum = 0;
          this.inForm.cargoWt = 0;
          this.inForm.cargoVol = 0;
        }
      })
    },
    getStockList(cargoId) {
      let param = {
        custId: this.form.custId,
        cargoId: cargoId,
      }
      warehouseList(param).then(response => {
        this.stockList = response.stockList
        this.listMap = response.listMap
      }).catch(e => {
      })
    },


    /** 查询货物转场列表 */
    getList() {
      this.loading = true;
      if(this.queryTime!=null){
        this.queryParams.beginDate=this.queryTime[0];
        this.queryParams.endDate=this.queryTime[1];
      }else{
        this.queryParams.beginDate=null;
        this.queryParams.endDate=null;
      }
      pageListCkcargo(this.queryParams).then(response => {
        this.ckcargoList = response.rows;
        this.total = response.total;
        this.loading = false;
      }).catch(e => {
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.show = 0;

      this.reset();
    },
    // 表单重置
    reset() {
      this.outForm = {
        cargoNum :0,
        cargoWt :0,
        cargoVol :0

      };
      this.inForm = {
        stockId: '',
        cargoNum :0,
        cargoWt :0,
        cargoVol :0
      };
      this.form = {
        id: null,
        outBillNumber:'',
        nowStockNum:0,
        nowStockWt:0,
        nowStockVol:0,
        outCargoNum:0,
        outCargoWt:0,
        outCargoVol:0,
        inCargoNum:0,
        inCargoWt:0,
        inCargoVol:0,
        billId: null,
        billDate: null,
        billNumber: null,
        inoutType: null,
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        remark: null,
        inStockId: null,
        inStockCode: null,
        inStockName: null,
        outStockId: null,
        outStockCode: null,
        outStockName: null,

      };

      this.resetForm("form");
    },
    //排序
    handleSortChange(col) {
      this.$sortBy(col, this.queryParams);
      this.getList();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryTime = [];
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.names = selection.map(item => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.show = 1;

      this.reset();
      this.title = "添加货物转场";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {

      this.reset();
      const id = row.id || this.ids;
      getCkcargo(id).then(response => {
        this.form = response.data;
        this.show = 1;
        this.title = "修改货物转场";
      });
    },
    /** 提交按钮 */
    submitForm() {

      this.$refs["form"].validate(valid => {
        if (valid) {
          if(!this.inForm.stockId||!this.inForm.cargoNum||!this.inForm.cargoWt||!this.inForm.cargoVol){
            this.$modal.alertError("转场货物库场必填、转场货物必须大于0");
            return;
          }
          this.$modal.msgSuccess("新增成功");
          this.reset()
          this.show = 0
          this.getList();
          /*    this.form
             this.outForm
             this.inForm
             addMixture(this.form).then(response => {
               this.$modal.msgSuccess("新增成功");
               this.reset()
               this.show = 0
               this.getList();
             }); */
        }
      });

    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const names = row.id || this.names;
      this.$modal.confirm('是否确认删除货物转场为"' + names + '"的数据项？').then(function () {
        return delCkcargo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('jxc/ckcargo/export', {
        ...this.queryParams
      }, `货物转场_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
